<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>
		Perl 6 Cheat Sheet v2
  </TITLE>
  <META NAME="Description" CONTENT="Perl 6 Cheat Sheet v2">
  <LINK REL="StyleSheet" HREF="cheatsheet.css" TYPE="text/css" MEDIA="screen">
  <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
</HEAD>
<BODY>

<H1>
Perl 6 cheat sheet v2
</H1>

<DIV id="container">

<DIV class="P6cheat" id="sigils">
<H2>Sigils</H2>
<P>
$scalar
@array
%hash
&amp;code
</P>
</DIV>

<DIV class="P6cheat" id="contexts">
<H2>Major/minor contexts</H2>
<P>
item   list    sink
Str    flat/slice
Num    lazy/eager/hyper
Bool
</P>
</DIV>

<DIV id="access_div">
<H2>Access</H2>

<TABLE class="access" id="access_table">
<TR id="top"><TH id="topleft"></TH><TH>Arrays</TH><TH id="topright">Hashes</TH></TR>
<TR><TH>whole</TH><TD>@array[]</TD><TD>%hash{}</TH></TR>
<TR><TH>element</TH><TD>@array[0]</TD><TD>%hash{'a'}<BR>%hash&lt;a&gt;</TD></TR>
<TR id="bot"><TH id="botleft">slice</TH><TD>@array[0,2]</TD><TD id="botright">%hash{'a','b'}<BR>%hash&lt;a&nbsp;b&gt;</TD></TR>
</TABLE>

</DIV> <!-- End access_div -->


<DIV class="P6cheat" id="twigils">
<H2>Twigils</H2>
<P>
$normal-lexical
$?compiler-constant
$*dynamic-or-global
$.public-accessor
$!private-attribute
$^positional-param
$:named-parameter
$=pod-info
$&lt;named-match-capture&gt;
$~slang-variable
</P>
</DIV>

<DIV class="P6cheat" id="composers">
<H2>Composers</H2>
<P>
[ ] array
{ } block/hash
&lt; &gt; quotewords
(,) parcel
:() signature
\() capture
</P>
</DIV>

<DIV class="P6cheat" id="automatic_dereference">
<H2>Automatic dereference</H2>
<P>
&amp;($foo)(1,2)     == $foo(1,2)
@($foo)[1]       == $foo[1]
%($foo){'bar'}   == $foo&lt;bar&gt;
@(@($foo)[1])[2] == $foo[1][2]
</P>
</DIV>


<DIV class="P6cheat" id="control_syntax">
<H2>Control syntax</H2>
<P>
for LIST { }                # implicit $_ arg
for LIST -&gt; $a, $b { }      # explicit args
while/until EXPR { }
repeat while/until EXPR { } # do at least once
loop { }   loop (a;b;c) { } # parens required!
if EXPR { } elsif EXPR { } else { }
unless EXPR { }             # no else allowed!
given EXPR { when EXPR { } default { } }
EXPR if EXPR for LIST;    # list comprehension
next, last, redo            # loop controls
proceed, succeed            # switch controls
</P>
</DIV>


<DIV class="P6cheat" id="operator_precedence">
<H2>Operator precedence</H2>
<P>
.method .[] i
++ --
**
unary + - ~ ! ? ^
* / % %% div
+ -
x xx
~
&amp;
| ^
sleep abs sin temp
&lt;=&gt; leg cmp .. but
~~ &gt; == gt eq === eqv !op
&amp;&amp;
|| ^^ // min max
??!! ff
= := op= =&gt;
so not
, :
X Xop Z Zop ...
say die map etc
and
or xor
&lt;== ==&gt;
</P>
</DIV>


<DIV class="P6cheat" id="scope_declarators">
<H2>Scope declarators</H2>
<P>
       my  lexical scope
      our  package scope
      has  instance scope
     anon  no scope at all
    state  persistent lexical
  augment  benign parasitic
supersede  deadly parasitic
</P>
</DIV>


<DIV class="P6cheat" id="types">
<H2>Types</H2>
<P>
Bool Bit Int Rat FatRat UInt Num Complex int32, complex64 etc.
Str Cat Blob Char Byte Codepoint Grapheme Buf buf8 buf32 utf8
IO Mu Any Cool Junction Whatever Match
Parcel Capture Signature
Pair Range Set Bag
KeyHash KeySet KeyBag
Scalar Array Hash Code
Enum Order TrigBase
Block Routine Sub
Method Regex
Failure Exception
Instant Duration
Date DateTime
</P>
</DIV>

<DIV class="P6cheat" id="operator_domains">
<H2>Operator domains</H2>
<P>
 Numeric: ==  !==(!=) + &lt;      &gt;     &lt;=&gt; &lt;=     &gt;=
 Stringy: eq  !eq(ne) ~ lt     gt    leg le     ge
         Value: eqv  !eqv     before after cmp !after !before
ObjectID: === !===
</P>
</DIV>

<DIV class="P6cheat" id="metaoperators">
<H2>Metaoperators</H2>
<P>
[op] reduce listop to A op B op C...
op=  A = A op B
!op  !(A op B)
»op« hyper/vectorize
Zop  zip with op
Xop  cross with op
Rop  reverse args
Sop  sequentialize
</P>
</DIV>

<DIV class="P6cheat" id="special_variables">
<H2>Special variables</H2>
<P>
$_     current topic
$/     regex result
$!     error object
@*ARGS command line
@*INC  include path
%*ENV  environment
$*PID  process id
</P>
</DIV>

<DIV class="P6cheat" id="regex_metachars">
<H2>Regex metachars</H2>
<P>
^ $    string begin/end
^^ $$  line begin/end
+      one or more
*      zero or more
?      zero or one
**1..3 repeat in range
()     capture to $0,$1
[]     no capture
&lt;foo&gt;  subrule
&lt;[]&gt;   character class
|      parallel or
||     serial or
« »    word boundary
</P>
</DIV>

<DIV class="P6cheat" id="regex_modifiers">
<H2>Regex modifiers</H2>
<P>
:i   ignore case
:m   ignore marks
:g   global
:r   ratchet
:s   sigspace
:4th nth occurrence
:4x  n times
</P>
</DIV>

<DIV class="P6cheat" id="regex_charclasses">
<H2>Regex charclasses</H2>
<P>
 . == anychar, \N non \n
\s == &lt;space&gt;, \S non
\d == &lt;digit&gt;, \D non
\w == &lt;+alpha+digit+[_]&gt;
</P>
</DIV>

<DIV class="P6cheat" id="links">
<H2>Links</H2>
<P>
 <a href="http://perl6.org">perl6.org</a>
 <a href="http://rakudo.org">rakudo.org</a>
</P>
</DIV>

<DIV class="P6cheat" id="IRC">
<H2>IRC</H2>
<P>
#perl6 irc.freenode.net
#parrot irc.perl.org
</P>
</DIV>

</DIV> <!-- End container -->
</BODY>
</HTML>

